/************************************************************************/
/*																		*/
/*		H S A _ T X . H  -  Define HSA_TEXT display routines			*/
/*																		*/
/************************************************************************/

/************************************************************************/
/*																		*/
/*		Copyright (c) Hardwood Software Associates, 1986				*/
/*																		*/
/************************************************************************/

/*************************************************************************
 *				H S A _ T X . H   E D I T   L O G 
 *
 * $Log:   D:/CRT/VCS/HSA_TX.H_V  $
 *	
 *	   Rev 1.12   09 Apr 1989 17:32:00   R. Evans
 *	Add tx_25.tx_43,tx_50
 *	
 *	   Rev 1.11   16 Sep 1988 21:10:02   R. Evans
 *	Add tx_mows_enable, tx_mows_disable, tx_mows_cursor, 
 *	tx_mows_get_status, tx_mows_put_status
 *	
 *	   Rev 1.10   08 Sep 1988 20:04:40   R. Evans
 *	Add tx_double_status
 *	
 *	   Rev 1.9   05 Sep 1988 16:19:34   R. Evans
 *	Add tx_set_double, tx_reset_double, tx_video_a, tx_video_i
 *	
 *	   Rev 1.8   14 Aug 1988 13:47:34   R. Evans
 *	Use tx_no_col for SCREEN_WIDTH & tx_no_row for SCREEN_SIZE
 *	
 *	   Rev 1.7   14 Aug 1988 13:41:56   R. Evans
 *	Add tx_no_row
 *	
 *	   Rev 1.6   14 Aug 1988 11:57:14   R. Evans
 *	Add tx_blink_on, tx_blink_off, tx_attr_o, tx_attr_o_c,
 *	tx_fill_attr,tx_fill_attr_c
 *	
 *	   Rev 1.5   30 Apr 1988 22:09:26   R. Evans
 *	tx_mows_press & tx_mows_release had incorrect arg types for 1 & 2
 *	Use hsa_attr.h
 *	
 *	   Rev 1.4   24 Apr 1988 15:23:32   R. Evans
 *	Eliminate non prototyped definitions
 *	mows_sensitivity name corrected.
 *	
 *	   Rev 1.3   21 Apr 1988 20:20:06   R. Evans
 *	Add REVERSE_ATTR macro
 *	
 *	   Rev 1.2   14 Feb 1988  9:30:50   R. Evans
 *	Add mouse types
 *	Add tx_scup_a & tx_scdn_a
 *	Add tx_adapt_1
 *	
 *	   Rev 1.1   07 Nov 1987 15:08:18   R. Evans
 *	Add mouse support
 *	
 *	   Rev 1.0   11 Aug 1987 11:47:24   R. Evans
 *	Initial revision.
 *
 ************************************************************************/

#ifndef TX_
#define TX_

#define SCREEN_WIDTH	(tx_no_col ())			/* Width of screen */
#define SCREEN_LENGTH	(tx_no_row ())			/* Length of screen */

#include <hsa_attr.h>							/* Screen Attributes */

struct crt_status
	{
	unsigned char mode;							/* Current CRT mode */
	unsigned char attribute;					/* Current default attributes */
	unsigned short row,column;					/* Current cursor location */
	};
#define CRT_STATUS struct crt_status

void tx_25 (void);
void tx_43 (void);
void tx_50 (void);
int tx_adapt1 (void);
int tx_video_a (void);
int tx_video_i (void);
int tx_double_status (void);
int tx_set_double (int);
void tx_reset_double (void);
short tx_attr (void);
void tx_attr_o (int, int, int);
void tx_attr_o_c (int);
void tx_attr_set (int);
void tx_bios (void);
void tx_blink(void);
void tx_blink_on (void);
void tx_blink_off (void);
void tx_bold(void);
void tx_b_b(void);
void tx_chr (short,short,char);
void tx_chr_a (short,short,char,short);
void tx_chr_a_c (char,short);
void tx_chr_c_a (char,short);
void tx_chr_c (char);
void tc_chr_o (int,int,char);
void tc_chr_o_c (char);
void tx_clr (void);
void tx_clr_a (int);
void tx_clr_eol(void);
void tx_clr_eol_a(int);
void tx_clr_rows (int,int);
void tx_clr_rows_a (int,int,int);
int tx_col (void);
void tx_conf (unsigned int, unsigned int);
void tx_cur_hide(void);
void tx_cur_set (int,int);
void tx_cur_show(void);
void tx_direct(void);
void tx_down (void);
void tx_fill (short,short,char,short);
void tx_fill_a (int,int,char,int,int);
void tx_fill_attr (int,int,int,int);
void tx_fill_attr_o (int,int);
void tx_fill_c (char,int);
void tx_fill_a_c (char,int,int);
void tx_fill_c_a (char,int,int);
void tx_get_status (CRT_STATUS *);
void tx_left (void);
void tx_loc (short,short);
void tx_mows_enable (void);
void tx_mows_disable (void);
int tx_mows_cursor (void);
int tx_mows_get_status (void);
int tx_mows_put_status (int);
int tx_mows_reset (void);
int tx_mows_type (void);
int tx_mows_show (void);
int tx_mows_hide (void);
int tx_mows_move (int,int);
int tx_mows_loc (int *,int *);
int tx_mows_button (void);
int tx_mows_window (int,int,int,int);
int tx_mows_press (int *,int *,int);
int tx_mows_release (int *,int *,int);
int tx_mows_window (int,int,int,int);
int tx_mows_hard_cur (int,int);
int tx_mows_soft_cur (int,int);
int tx_mows_sensitivity (int,int);
void tx_nl (void);
void tx_norm(void);
int tx_no_col (void);
int tx_no_row (void);
void tx_no_snow (void);
void tx_put_status (CRT_STATUS *);
void tx_rd_blk (int,int,int *,int,int);
void tx_rd_blk_c (int *,int,int);
char *tx_rd_str (short, short, char *, short);
char *tx_rd_str_c (char *, short);
void tx_reverse(void);
void tx_right (void);
short tx_row (void);
void tx_scdn (int,int,int,int);
void tx_scdn_a (int,int,int,int,int);
void tx_scup (int,int,int,int);
void tx_scup_a (int,int,int,int,int);
void tx_snow (void);
int tx_state (void);
void tx_str (short,short,char *);
void tx_str_a (short,short,char *,short);
void tx_str_a_c (char *,short);
void tx_str_c_a (char *,short);
void tx_str_c (char *);
void tx_under (void);
void tx_up (void);
void tx_wr_blk (int,int,int *,int,int);
void tx_wr_blk_c (int *,int,int);
#endif
